/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package distributeur {
	import com.demonsters.debugger.MonsterDebugger;
	import flash.errors.IllegalOperationError;

	import flash.utils.getQualifiedClassName;
	
	
	/**
	 * @author Matthieu
	 * 
	 * Classe abstraite Boisson
	 * 
	 */
	public class AbstractBoisson 
	{
		
		protected var sDescription : String;// description de la boisson
		protected var nPrice : Number;// prix de la boisson
		
		
		
		/**
		 * Constructeur protégé pour ne pas être instancié directement.
		 * 
		 */
		public function AbstractBoisson() 
		{
			if(getQualifiedClassName(this) == "AbstractBoisson")
				throw new IllegalOperationError("AbstractBoisson est une classe Abstraite, vous ne pouvez pas l'instancier directement.");
			
			MonsterDebugger.trace(this, "constructeur AbstractBoisson : " + getQualifiedClassName(this));
		}


		/**
		 * Renvoie la description de la boisson.
		 * 
		 */
		public function getDescription() : String 
		{
			return sDescription;
		}
		
		
		/**
		 * Renvoie le tarif de la boisson.
		 * 
		 */
		public function count() : Number 
		{
			return nPrice;
		}
		
		
	}
}
